// Realtime Raytracing Vizualizer "RAVI" Demo V0.35
// ------------------------------------------------
// (C) 02/04/2004                     Michael Granz

#include "stdafx.h"
#include "RaVi-Demo.h"

#include "MainFrm.h"

#include "general.h"
#include "materials.h"
#include "RaVi.h"

#ifdef _DEBUG
  #define new DEBUG_NEW
  #undef THIS_FILE
  static char THIS_FILE[] = __FILE__;
#endif

extern RV_PrP    RV_LtObj;

extern CStatusBar *StatusBar;
       CMainFrame *Win;

short     Animation = 1;
short     Demo      = 1;

float     wavlen = 555.0f;

float     C1=1.3f;
float     C2=0.3f;

MatPtr    MatList  = NULL;

Material  ENVIRONMENT;

matrix    ActM,ActB;
RV_PrP    Act1,Act2,Act3,Act4,Act5,Act6;


/*void KillScene()
{
  RV_PrP pp;
  while(RV_Scene){
    pp=RV_Scene; RV_Scene = RV_Scene->next;
    delete(pp);
  } 
  MatPtr mp;
  while(MatList){
    mp=MatList; MatList = MatList->next;
    delete(mp);
  }
}*/

void InitSphereScene()
{
  RV_Lights->p = vector(5.0f, -3.0f, 7.0f); RV_Lights->Prim=NULL;
  RV_Target    = vector(0.0f,  0.0f, 1.2f); RV_Up = vector(0.0f,  0.0f, 1.0f); RV_FoV = 0.5f;

  MatPtr mat=new Material; mat->next=MatList; MatList=mat; mat->PBExp = 20.0f;
  mat->Reflection=RGB_Color(0.9f, 0.8f, 0.2f);
  mat->Specularity=0.5f; mat->type=0; mat->name = strdup("Metal");

  RV_SimpleSphere *s = new RV_SimpleSphere; s->Mat=mat; Act1=s;
  s->position=vector(0.0f, 0.0f, 1.0f); s->flags = RV_ReceiveNoShadow;
  PrLP o = new(PrLst); o->Prim = s;
  
         mat=new Material; mat->next=MatList; MatList=mat; mat->PBExp = 20.0f;
  mat->Reflection=RGB_Color(0.2f, 0.3f, 0.8f);
  mat->Specularity=0.0f; mat->type=Shader_Phong; mat->name = strdup("Ground");

  RV_TriPara *p = new RV_TriPara; p->type=1; p->flags=RV_CastNoShadow | RV_Chequered; p->Mat=mat;
  p->base=vector(-2.0f,-2.0f, 0.0f);
  p->edg1=vector( 4.0f, 0.0f, 0.0f);
  p->edg2=vector( 0.0f, 4.0f, 0.0f);
  InitTP(p); Win->SetWindowText("RAVI-Demo: Bouncing Mirrorsphere"); BBMin=vector(-2.0f,-2.0f,-0.001f); BBMax=vector(2.0f,2.0f,3.0f); RV_LtObj=NULL;
  o->next = new(PrLst); o->next->Prim = p;
  o->next->next = NULL;

  // set up BSP-tree
  RV_SceneTree = new(BSPplane); RV_SceneTree->axis=0; RV_SceneTree->left=(BSPplane *)o;
}

void Init3SpheresScene()
{
  MatPtr mat; RV_SimpleSphere *s;
  RV_Target    = vector(0.0f,  0.0f, 0.0f); RV_Up = vector(0.0f,  0.0f, 1.0f); RV_FoV = 0.5f;
  RV_Lights->p = vector(5.0f, -3.0f, 7.0f); RV_Lights->Prim=NULL;
  
  mat=new Material; mat->next=MatList; MatList=mat; mat->PBExp = 20.0f;
  mat->Reflection=RGB_Color(0.9f, 0.8f, 0.4f);
  mat->Specularity=0.5f; mat->type=0; mat->name = strdup("Gold");
  s = new RV_SimpleSphere; s->r2=0.25f; s->Mat=mat; Act1=s;
  s->position=vector(1.0f, 0.0f, 0.5f); s->flags = RV_ReceiveNoShadow;
  PrLP o = new(PrLst); o->Prim = s;
  
  mat=new Material; mat->next=MatList; MatList=mat; mat->PBExp = 20.0f;
  mat->Reflection=RGB_Color(0.8f, 0.8f, 0.7f);
  mat->Specularity=0.5f; mat->type=0; mat->name = strdup("Silver");
  s = new RV_SimpleSphere; s->r2=0.25f; s->Mat=mat; Act2=s;
  s->position=vector(cosf(2.0944f), sinf(2.0944f), 0.5f); s->flags = RV_ReceiveNoShadow;
  o->next = new(PrLst); o->next->Prim = s;

  mat=new Material; mat->next=MatList; MatList=mat; mat->PBExp = 20.0f;
  mat->Reflection=RGB_Color(0.9f, 0.6f, 0.5f);
  mat->Specularity=0.5f; mat->type=0; mat->name = strdup("Copper");
  s = new RV_SimpleSphere; s->r2=0.25f; s->Mat=mat; Act3=s;
  s->position=vector(cosf(-2.0944f), sinf(-2.0944f), 0.5f); s->flags = RV_ReceiveNoShadow;
  o->next->next = new(PrLst); o->next->next->Prim = s;
  
         mat=new Material; mat->next=MatList; MatList=mat; mat->PBExp = 20.0f;
  mat->Reflection=RGB_Color(0.2f, 0.3f, 0.8f);
  mat->Specularity=0.2f; mat->type=Shader_Phong; mat->name = strdup("Ground");

  RV_TriPara *p = new RV_TriPara; p->type=1; p->flags=RV_CastNoShadow | RV_Chequered; p->Mat=mat;
  p->base=vector(-2.0f,-2.0f, 0.0f);
  p->edg1=vector( 4.0f, 0.0f, 0.0f);
  p->edg2=vector( 0.0f, 4.0f, 0.0f);
  InitTP(p); Win->SetWindowText("RAVI-Demo: 3 rotating Spheres"); BBMin=vector(-2.0f,-2.0f,-0.001f); BBMax=vector(2.0f,2.0f,1.0f); RV_LtObj=NULL;
  o->next->next->next = new(PrLst); o->next->next->next->Prim = p;
  o->next->next->next->next = NULL;

  // set up BSP-tree
  RV_SceneTree = new(BSPplane); RV_SceneTree->axis=0; RV_SceneTree->left=(BSPplane *)o;
}

void InitSphereHeapScene()
{
  MatPtr mat; RV_SimpleSphere *s;
  RV_Target    = vector(0.0f,  0.0f, 1.0f); RV_Up = vector(0.0f,  0.0f, 1.0f); RV_FoV = 0.5f;
  RV_Lights->p = vector(5.0f, -3.0f, 7.0f); RV_Lights->Prim=NULL;
  
  mat=new Material; mat->next=MatList; MatList=mat; mat->PBExp = 20.0f;
  mat->Reflection=RGB_Color(0.9f, 0.8f, 0.4f);
  mat->Specularity=0.2f; mat->type=Shader_Phong; mat->name = strdup("Gold");
  s = new RV_SimpleSphere; s->r2=0.25f; s->Mat=mat; Act1=s;
  s->position=vector( 1.0f, 0.0f, 1.5f); s->flags = RV_ReceiveNoShadow;
  PrLP o = new(PrLst); o->Prim = s;
  s = new RV_SimpleSphere; s->r2=0.25f; s->Mat=mat;
  s->position=vector( 1.0f, 0.0f, 0.5f); s->flags = RV_ReceiveNoShadow;
  o->next = new(PrLst); o->next->Prim = s;
  s = new RV_SimpleSphere; s->r2=0.25f; s->Mat=mat;
  s->position=vector(-1.0f, 0.0f, 0.5f); s->flags = RV_ReceiveNoShadow;
  o->next->next = new(PrLst); o->next->next->Prim = s;

  mat=new Material; mat->next=MatList; MatList=mat; mat->PBExp = 20.0f;
  mat->Reflection=RGB_Color(0.8f, 0.8f, 0.7f);
  mat->Specularity=0.2f; mat->type=Shader_Phong; mat->name = strdup("Silver");
  s = new RV_SimpleSphere; s->r2=0.25f; s->Mat=mat; Act2=s;
  s->position=vector( cosf(2.0944f),  sinf(2.0944f), 1.5f); s->flags = RV_ReceiveNoShadow;
  o->next->next->next = new(PrLst); o->next->next->next->Prim = s;
  s = new RV_SimpleSphere; s->r2=0.25f; s->Mat=mat;
  s->position=vector( cosf(2.0944f),  sinf(2.0944f), 0.5f); s->flags = RV_ReceiveNoShadow;
  o->next->next->next->next = new(PrLst); o->next->next->next->next->Prim = s;
  s = new RV_SimpleSphere; s->r2=0.25f; s->Mat=mat;
  s->position=vector(-cosf(2.0944f), -sinf(2.0944f), 0.5f); s->flags = RV_ReceiveNoShadow;
  o->next->next->next->next->next = new(PrLst); o->next->next->next->next->next->Prim = s;

  mat=new Material; mat->next=MatList; MatList=mat; mat->PBExp = 20.0f;
  mat->Reflection=RGB_Color(0.9f, 0.6f, 0.5f);
  mat->Specularity=0.2f; mat->type=Shader_Phong; mat->name = strdup("Copper");
  s = new RV_SimpleSphere; s->r2=0.25f; s->Mat=mat; Act3=s;
  s->position=vector( cosf(-2.0944f),  sinf(-2.0944f), 1.5f); s->flags = RV_ReceiveNoShadow;
  o->next->next->next->next->next->next = new(PrLst); o->next->next->next->next->next->next->Prim = s;
  s = new RV_SimpleSphere; s->r2=0.25f; s->Mat=mat;
  s->position=vector( cosf(-2.0944f),  sinf(-2.0944f), 0.5f); s->flags = RV_ReceiveNoShadow;
  o->next->next->next->next->next->next->next = new(PrLst); o->next->next->next->next->next->next->next->Prim = s;
  s = new RV_SimpleSphere; s->r2=0.25f; s->Mat=mat;
  s->position=vector(-cosf(-2.0944f), -sinf(-2.0944f), 0.5f); s->flags = RV_ReceiveNoShadow;
  o->next->next->next->next->next->next->next->next = new(PrLst); o->next->next->next->next->next->next->next->next->Prim = s;

  mat=new Material; mat->next=MatList; MatList=mat; mat->PBExp = 20.0f;
  mat->Reflection=RGB_Color(0.7f, 0.5f, 0.9f);
  mat->Specularity=0.2f; mat->type=Shader_Phong; mat->name = strdup("Metal");
  s = new RV_SimpleSphere; s->r2=0.6f; s->Mat=mat;
  s->position=vector(0.0f, 0.0f, 1.0f); s->flags = RV_ReceiveNoShadow;
  o->next->next->next->next->next->next->next->next->next = new(PrLst); o->next->next->next->next->next->next->next->next->next->Prim = s;
  s = new RV_SimpleSphere; s->r2=0.2f; s->Mat=mat;
  s->position=vector(0.0f, 0.0f, 1.6f); s->flags = RV_ReceiveNoShadow;
  o->next->next->next->next->next->next->next->next->next->next = new(PrLst); o->next->next->next->next->next->next->next->next->next->next->Prim = s;
  o->next->next->next->next->next->next->next->next->next->next->next = NULL;

  // set up BSP-tree
  RV_SceneTree = new(BSPplane); RV_SceneTree->axis=0; RV_SceneTree->left=(BSPplane *)o;
  Win->SetWindowText("RAVI-Demo: 3 rotating Spheres"); BBMin=vector(-2.0f,-2.0f,-0.001f); BBMax=vector(2.0f,2.0f,2.5f); RV_LtObj=NULL;
}

void InitTorusScene()
{
  RV_Lights->p = vector(5.0f, -3.0f, 7.0f); RV_Lights->Prim=NULL;
  RV_Target    = vector(0.0f,  0.0f, 1.2f); RV_Up = vector(0.0f,  0.0f, 1.0f); RV_FoV = 0.5f;

  MatPtr mat=new Material; mat->next=MatList; MatList=mat; mat->PBExp = 20.0f;
  mat->Reflection=RGB_Color(0.9f, 0.5f, 0.2f);
  mat->Specularity=0.5f; mat->type=Shader_Phong; mat->name = strdup("Plastic");

  RV_Torus *t = new RV_Torus; t->Mat=mat; Act1=t;
  ActM.InitIdentMat(); ActM.RotateX(0.7853981634f); ActM.Translate(0.0f, 0.0f, 1.2071f);
  t->Tb=ActM.Inverse(); t->sinfo = new RV_GenShd; t->sinfo->NM = ActM.NTrans();
  PrLP o = new(PrLst); o->Prim = t;

         mat=new Material; mat->next=MatList; MatList=mat; mat->PBExp = 20.0f;
  mat->Reflection=RGB_Color(0.2f, 0.3f, 0.8f);
  mat->Specularity=0.0f; mat->type=Shader_Phong; mat->name = strdup("Ground");

  RV_TriPara *p = new RV_TriPara; p->type=1; p->flags=RV_CastNoShadow | RV_Chequered; p->Mat=mat;
  p->base=vector(-2.0f,-2.0f, 0.0f);
  p->edg1=vector( 4.0f, 0.0f, 0.0f);
  p->edg2=vector( 0.0f, 4.0f, 0.0f);
  InitTP(p); Win->SetWindowText("RAVI-Demo: rotating Torus"); BBMin=vector(-2.0f,-2.0f,-0.001f); BBMax=vector(2.0f,2.0f,2.5f); RV_LtObj=NULL;
  o->next = new(PrLst); o->next->Prim = p;
  o->next->next = NULL;

  // set up BSP-tree
  RV_SceneTree = new(BSPplane); RV_SceneTree->axis=0; RV_SceneTree->left=(BSPplane *)o;
}

void InitCubeScene()
{
  RV_Target    = vector(0.0f,  0.0f, 1.2f); RV_Up = vector(0.0f,  0.0f, 1.0f); RV_FoV = 0.5f;
  RV_Lights->p = vector(5.0f, -3.0f, 7.0f); RV_Lights->Prim=NULL;

  MatPtr mat=new Material; mat->next=MatList; MatList=mat; mat->PBExp = 20.0f;
  mat->Reflection=RGB_Color(0.6f, 0.3f, 0.2f);
  mat->Specularity=0.2f; mat->type=Shader_Phong; mat->name = strdup("Ground");

  RV_TriPara *p = new RV_TriPara; p->type=1; p->flags=RV_CastNoShadow | RV_Chequered; p->Mat=mat;
  p->base=vector(-2.0f,-2.0f, 0.0f);
  p->edg1=vector( 4.0f, 0.0f, 0.0f);
  p->edg2=vector( 0.0f, 4.0f, 0.0f);
  InitTP(p); PrLP o = new(PrLst); o->Prim = p;

  mat=new Material; mat->next=MatList; MatList=mat; mat->PBExp = 20.0f;
  mat->Reflection=RGB_Color(0.2f, 0.9f, 0.8f); mat->Transmission=RGB_Color(-1.0f, -1.0f, -1.0f); mat->IOR_base=1.54f;
  mat->Specularity=0.70f; mat->type=0; mat->name = strdup("Glass");

  /*RV_Cube *c = new RV_Cube; c->Mat=mat; c->flags = RV_ReceiveNoShadow; Act1=c;
  ActM.InitIdentMat(); ActM.Scale(1.5f, 1.5f, 1.5f); ActM.RotateX(0.78539f); ActM.RotateY(0.61548f); ActM.Translate(0.0f, 0.0f, 1.3f);
  InitCube(c, ActM); o->next = new(PrLst); o->next->Prim = c; o->next->next=NULL;*/

  ActM.InitIdentMat(); ActM.Scale(1.5f, 1.5f, 1.5f); ActM.RotateX(0.78539f); ActM.RotateY(0.61548f); matrix NM=ActM; ActM.Translate(0.0f, 0.0f, 1.3f);

  p = new RV_TriPara; p->type=1; p->flags=RV_ReceiveNoShadow; p->Mat=mat; Act1=p;
  p->base=vector(-0.5f, -0.5f, -0.5f)*ActM;
  p->edg2=vector( 1.0f,  0.0f,  0.0f)*NM;
  p->edg1=vector( 0.0f,  1.0f,  0.0f)*NM;
  InitTP(p); o->next = new(PrLst); o->next->Prim = p;

  p = new RV_TriPara; p->type=1; p->flags=RV_ReceiveNoShadow; p->Mat=mat; Act2=p;
  p->base=vector(-0.5f, -0.5f, -0.5f)*ActM;
  p->edg2=vector( 0.0f,  1.0f,  0.0f)*NM;
  p->edg1=vector( 0.0f,  0.0f,  1.0f)*NM;
  InitTP(p); o->next->next = new(PrLst); o->next->next->Prim = p;
  
  p = new RV_TriPara; p->type=1; p->flags=RV_ReceiveNoShadow; p->Mat=mat; Act3=p;
  p->base=vector(-0.5f, -0.5f, -0.5f)*ActM;
  p->edg2=vector( 0.0f,  0.0f,  1.0f)*NM;
  p->edg1=vector( 1.0f,  0.0f,  0.0f)*NM;
  InitTP(p); o->next->next->next = new(PrLst); o->next->next->next->Prim = p;

  p = new RV_TriPara; p->type=1; p->flags=RV_ReceiveNoShadow; p->Mat=mat; Act4=p;
  p->base=vector( 0.5f,  0.5f,  0.5f)*ActM;
  p->edg1=vector(-1.0f,  0.0f,  0.0f)*NM;
  p->edg2=vector( 0.0f, -1.0f,  0.0f)*NM;
  InitTP(p); o->next->next->next->next = new(PrLst); o->next->next->next->next->Prim = p;

  p = new RV_TriPara; p->type=1; p->flags=RV_ReceiveNoShadow; p->Mat=mat; Act5=p;
  p->base=vector( 0.5f,  0.5f,  0.5f)*ActM;
  p->edg1=vector( 0.0f, -1.0f,  0.0f)*NM;
  p->edg2=vector( 0.0f,  0.0f, -1.0f)*NM;
  InitTP(p); o->next->next->next->next->next = new(PrLst); o->next->next->next->next->next->Prim = p;
  
  p = new RV_TriPara; p->type=1; p->flags=RV_ReceiveNoShadow; p->Mat=mat; Act6=p;
  p->base=vector( 0.5f,  0.5f,  0.5f)*ActM;
  p->edg1=vector( 0.0f,  0.0f, -1.0f)*NM;
  p->edg2=vector(-1.0f,  0.0f,  0.0f)*NM;
  InitTP(p); o->next->next->next->next->next->next = new(PrLst); o->next->next->next->next->next->next->Prim = p;
  InitTP(p); o->next->next->next->next->next->next->next = NULL;

  /*mat=new Material; mat->next=MatList; MatList=mat; mat->PBExp = 5.0f;
  mat->Reflection=RGB_Color(0.9f, 0.8f, 0.7f);
  mat->Specularity=0.2f; mat->type=Shader_Phong; mat->name = strdup("Clay");

  p = new RV_TriPara; p->type=0; p->flags=RV_SingleSided; p->Mat=mat;
  p->base=vector( 0.9f, 0.8f, 0.0f); p->edg1=vector(-0.3f, 0.0f, 1.0f); p->edg2=vector(-0.6f, 0.0f, 0.0f); InitTP(p);
  o->next->next->next->next->next->next->next = new(PrLst); o->next->next->next->next->next->next->next->Prim = p;

  p = new RV_TriPara; p->type=1; p->flags=RV_SingleSided; p->Mat=mat;
  p->base=vector( 0.3f, 0.8f, 0.0f); p->edg2=vector( 0.0f, 0.8f, 0.0f); p->edg1=vector( 0.3f, 0.0f, 1.0f); InitTP(p);
  o->next->next->next->next->next->next->next->next = new(PrLst); o->next->next->next->next->next->next->next->next->Prim = p;

  p = new RV_TriPara; p->type=1; p->flags=RV_SingleSided; p->Mat=mat;
  p->base=vector( 0.9f, 0.8f, 0.0f); p->edg1=vector( 0.0f, 0.8f, 0.0f); p->edg2=vector(-0.3f, 0.0f, 1.0f); InitTP(p);
  o->next->next->next->next->next->next->next->next->next = new(PrLst); o->next->next->next->next->next->next->next->next->next->Prim = p;
 
  p = new RV_TriPara; p->type=0; p->flags=RV_SingleSided; p->Mat=mat;
  p->base=vector( 0.9f, 1.6f, 0.0f); p->edg1=vector(-0.6f, 0.0f, 0.0f); p->edg2=vector(-0.3f, 0.0f, 1.0f); InitTP(p);
  o->next->next->next->next->next->next->next->next->next->next = new(PrLst); o->next->next->next->next->next->next->next->next->next->next->Prim = p;
  o->next->next->next->next->next->next->next->next->next->next->next = NULL;*/

  // set up BSP-tree
  RV_SceneTree = new(BSPplane); RV_SceneTree->axis=0; RV_SceneTree->left=(BSPplane *)o;
  Win->SetWindowText("RAVI-Demo: Spinning Glass Cube"); BBMin=vector(-2.0f,-2.0f,-0.001f); BBMax=vector(2.0f,2.0f,2.6f); RV_LtObj=NULL;
}

void InitShadowScene()
{
  RV_Target    = vector(0.0f,  0.0f, 0.5f); RV_Up = vector(0.0f,  0.0f, 1.0f); RV_FoV = 0.5f;
  RV_Lights->p = vector(5.0f, -3.0f, 7.0f); RV_Lights->Prim=NULL;

  MatPtr mat=new Material; mat->next=MatList; MatList=mat; mat->PBExp = 0.0f;
  mat->Reflection=RGB_Color(5.0f, 5.0f, 5.0f);
  mat->Specularity=0.0f; mat->type=Shader_Phong; mat->name = strdup("Light");

  RV_SimpleSphere *s = new RV_SimpleSphere; s->r2=0.01f; s->Mat=mat; Act1=s; RV_LtObj=s;
  s->position=vector(1.0f, 0.0f, 1.0f); s->flags = (RV_CastNoShadow | RV_ReceiveNoShadow);

  mat=new Material; mat->next=MatList; MatList=mat; mat->PBExp = 20.0f;
  mat->Reflection=RGB_Color(0.1f, 0.6f, 0.2f);
  mat->Specularity=0.2f; mat->type=Shader_Phong; mat->name = strdup("Ground");

  RV_TriPara *p = new RV_TriPara; p->type=1; p->flags=RV_CastNoShadow | RV_Chequered; p->Mat=mat; Act2=p;
  p->base=vector(-2.0f,-2.0f, 0.0f);
  p->edg1=vector( 4.0f, 0.0f, 0.0f);
  p->edg2=vector( 0.0f, 4.0f, 0.0f);
  InitTP(p); PrLP l = new(PrLst); l->Prim = p;

  mat=new Material; mat->next=MatList; MatList=mat; mat->PBExp = 5.0f;
  mat->Reflection=RGB_Color(0.9f, 0.8f, 0.7f);
  mat->Specularity=0.2f; mat->type=Shader_Phong; mat->name = strdup("Clay");

  //RV_Cylinder *c = new RV_Cylinder; c->Mat=mat;
  //ActM.InitIdentMat(); ActM.Scale(0.25f, 0.25f, 1.5f); ActM.Translate(-1.3f, 0.0f, 0.0f);
  //c->Tb=ActM.Inverse(); c->sinfo = new RV_GenShd; c->sinfo->NM = ActM.NTrans();
  //l->next = new(PrLst); l->next->Prim = c;

  s = new RV_SimpleSphere; s->r2=0.25f; s->position=vector(0.0f, -1.0f, 0.5f); s->Mat=mat;
  l->next = new(PrLst); l->next->Prim = s;

  p = new RV_TriPara; p->type=0; p->flags=RV_SingleSided; p->Mat=mat;
  p->base=vector( 0.6f, 0.0f, 0.0f); p->edg1=vector(-0.3f, 0.0f, 1.0f); p->edg2=vector(-0.6f, 0.0f, 0.0f); InitTP(p);
  l->next->next = new(PrLst); l->next->next->Prim = p;

  p = new RV_TriPara; p->type=1; p->flags=RV_SingleSided; p->Mat=mat;
  p->base=vector( 0.0f, 0.0f, 0.0f); p->edg2=vector( 0.0f, 0.8f, 0.0f); p->edg1=vector( 0.3f, 0.0f, 1.0f); InitTP(p);
  l->next->next->next = new(PrLst); l->next->next->next->Prim = p;

  p = new RV_TriPara; p->type=1; p->flags=RV_SingleSided; p->Mat=mat;
  p->base=vector( 0.6f, 0.0f, 0.0f); p->edg1=vector( 0.0f, 0.8f, 0.0f); p->edg2=vector(-0.3f, 0.0f, 1.0f); InitTP(p);
  l->next->next->next->next = new(PrLst); l->next->next->next->next->Prim = p;
 
  p = new RV_TriPara; p->type=0; p->flags=RV_SingleSided; p->Mat=mat;
  p->base=vector( 0.6f, 0.8f, 0.0f); p->edg1=vector(-0.6f, 0.0f, 0.0f); p->edg2=vector(-0.3f, 0.0f, 1.0f); InitTP(p);
  l->next->next->next->next->next = new(PrLst); l->next->next->next->next->next->Prim = p;
  l->next->next->next->next->next->next = NULL;

  // set up BSP-tree
  RV_SceneTree = new(BSPplane); RV_SceneTree->axis=0; RV_SceneTree->left=(BSPplane *)l;

  Win->SetWindowText("RAVI-Demo: Moving Light"); BBMin=vector(-2.0f,-2.0f,-0.001f); BBMax=vector(2.0f,2.0f,1.5f);
}

void InitAreaLightScene()
{
  RV_Target    = vector(0.00f, 0.00f, 0.50f); RV_Up = vector(0.0f,  0.0f, 1.0f); RV_FoV = 0.5f;
  RV_Lights->p = vector(0.85f,-0.85f, 2.10f);

  MatPtr mat=new Material; mat->next=MatList; MatList=mat; mat->PBExp = 0.0f;
  mat->Reflection=RGB_Color(5.0f, 5.0f, 5.0f);
  mat->Specularity=0.0f; mat->type=Shader_Phong; mat->name = strdup("Light");

  RV_TriPara *s = new RV_TriPara; s->type=1; s->flags=RV_CastNoShadow | RV_ReceiveNoShadow; s->Mat=mat; Act1=s; RV_LtObj=s; RV_Lights->Prim=s;
  s->base=vector( 1.0f,-1.0f, 2.0f);
  s->edg1=vector(-0.3f, 0.0f, 0.2f);
  s->edg2=vector( 0.0f, 0.3f, 0.0f);
  InitTP(s);

  mat=new Material; mat->next=MatList; MatList=mat; mat->PBExp = 20.0f;
  mat->Reflection=RGB_Color(0.1f, 0.6f, 0.2f);
  mat->Specularity=0.2f; mat->type=Shader_Phong; mat->name = strdup("Ground");

  RV_TriPara *p = new RV_TriPara; p->type=1; p->flags=RV_CastNoShadow; p->Mat=mat; Act2=p;
  p->base=vector(-2.0f,-2.0f, 0.0f);
  p->edg1=vector( 4.0f, 0.0f, 0.0f);
  p->edg2=vector( 0.0f, 4.0f, 0.0f);
  InitTP(p); PrLP l = new(PrLst); l->Prim = p;

  mat=new Material; mat->next=MatList; MatList=mat; mat->PBExp = 5.0f;
  mat->Reflection=RGB_Color(0.9f, 0.8f, 0.7f);
  mat->Specularity=0.2f; mat->type=Shader_Phong; mat->name = strdup("Clay");

  RV_Cylinder *c = new RV_Cylinder; c->Mat=mat;
  ActM.InitIdentMat(); ActM.Scale(0.25f, 0.25f, 1.0f);
  c->Tb=ActM.Inverse(); c->sinfo = new RV_GenShd; c->sinfo->NM = ActM.NTrans();
  l->next = new(PrLst); l->next->Prim = c;

  RV_SimpleRing *d = new RV_SimpleRing; d->r_o=sqr(0.25f); d->Mat=mat;
  ActM.InitIdentMat(); ActM.Translate(0.0f, 0.0f, 1.0f);
  d->center=vector(0.0f, 0.0f, 0.0f)*ActM; d->N=vector(0.0f, 0.0f, 1.0f)*ActM.NTrans();
  l->next->next = new(PrLst); l->next->next->Prim = d;

  l->next->next->next = NULL;

  // set up BSP-tree
  RV_SceneTree = new(BSPplane); RV_SceneTree->axis=0; RV_SceneTree->left=(BSPplane *)l;

  Win->SetWindowText("RAVI-Demo: Area Light's Soft Shadow"); BBMin=vector(-2.0f,-2.0f,-0.001f); BBMax=vector(2.0f,2.0f,2.5f);
}

/////////////////////////////////////////////////////////////////////////////
// cRaViApp

BEGIN_MESSAGE_MAP(cRaViApp, CWinApp)
	//{{AFX_MSG_MAP(cRaViApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_UPDATE_COMMAND_UI(ID_DEMO_ANIM, OnUpdateAnimation)
	ON_COMMAND(ID_DEMO_ANIM, OnAnimationToggle)
	ON_COMMAND(ID_QUALITY_1by1, OnQuality_1by1)
	ON_UPDATE_COMMAND_UI(ID_QUALITY_1by1, OnUpdateQuality_1by1)
	ON_COMMAND(ID_QUALITY_SUBSAMPLING, OnQualitySubsampling)
	ON_COMMAND(ID_DEMO_CUBE, OnDemoCube)
	ON_COMMAND(ID_DEMO_MIRRORSPHERE, OnMirrorSphere)
	ON_UPDATE_COMMAND_UI(ID_DEMO_MIRRORSPHERE, OnUpdateDemoMirrSph)
	ON_UPDATE_COMMAND_UI(ID_DEMO_CUBE, OnUpdateDemoCube)
	ON_COMMAND(ID_DEMO_3SPHERES, OnDemo3Spheres)
	ON_UPDATE_COMMAND_UI(ID_DEMO_3SPHERES, OnUpdate3Spheres)
	ON_COMMAND(ID_DEMO_SHADOWS, OnDemoShadows)
	ON_UPDATE_COMMAND_UI(ID_DEMO_SHADOWS, OnUpdateShadows)
	ON_COMMAND(ID_SHADER_NORMALS, OnShaderNormals)
	ON_COMMAND(ID_SHADER_PHONG, OnShaderPhong)
	ON_COMMAND(ID_SHADER_REFLECTION, OnShaderReflection)
	ON_UPDATE_COMMAND_UI(ID_SHADER_NORMALS, OnUpdateShaderNormals)
	ON_UPDATE_COMMAND_UI(ID_SHADER_PHONG, OnUpdateShaderPhong)
	ON_UPDATE_COMMAND_UI(ID_SHADER_REFLECTION, OnUpdateShaderReflection)
	ON_COMMAND(ID_SHADER_DEPTH, OnShaderDepth)
	ON_UPDATE_COMMAND_UI(ID_SHADER_DEPTH, OnUpdateShaderDepth)
	ON_COMMAND(ID_FILTER, OnFilter)
	ON_UPDATE_COMMAND_UI(ID_FILTER, OnUpdateFilter)
	ON_COMMAND(ID_ANTIALIAS, OnAntialiasToggle)
	ON_UPDATE_COMMAND_UI(ID_ANTIALIAS, OnUpdateAntialias)
	ON_UPDATE_COMMAND_UI(ID_QUALITY_SUBSAMPLING, OnUpdateQualitySub)
	ON_COMMAND(ID_DEMO_TORUS, OnDemoTorus)
	ON_UPDATE_COMMAND_UI(ID_DEMO_TORUS, OnUpdateDemoTorus)
	ON_COMMAND(ID_QUALITY_4by4, OnQUALITY_4by4)
	ON_UPDATE_COMMAND_UI(ID_QUALITY_4by4, OnUpdateQuality_4by4)
	ON_COMMAND(ID_SHADER_UV, OnShaderUV)
	ON_UPDATE_COMMAND_UI(ID_SHADER_UV, OnUpdateShaderUV)
	ON_COMMAND(ID_SHADER_SIMPLE, OnShaderSimple)
	ON_UPDATE_COMMAND_UI(ID_SHADER_SIMPLE, OnUpdateShaderSimple)
	ON_COMMAND(ID_DEMO_SPHEREHEAP, OnDemoSphereHeap)
	ON_UPDATE_COMMAND_UI(ID_DEMO_SPHEREHEAP, OnUpdateDemoSphereHeap)
	ON_COMMAND(ID_DEMO_SHADOWS3, OnDemoAreaLight)
	ON_UPDATE_COMMAND_UI(ID_DEMO_SHADOWS3, OnUpdateDemoAreaLight)
	ON_COMMAND(ID_RES480, OnRes480)
	ON_COMMAND(ID_RES320, OnRes320)
	ON_COMMAND(ID_RES512, OnRes512)
	ON_COMMAND(ID_RES640, OnRes640)
	ON_COMMAND(ID_RES800, OnRes800)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// cRaViApp Konstruktion

cRaViApp::cRaViApp()
{
	// ZU ERLEDIGEN: Hier Code zur Konstruktion einfgen
	// Alle wichtigen Initialisierungen in InitInstance platzieren
}

/////////////////////////////////////////////////////////////////////////////
// Das einzige cRaViApp-Objekt

cRaViApp theApp;

/////////////////////////////////////////////////////////////////////////////
// cRaViApp Initialisierung

BOOL cRaViApp::InitInstance()
{
  // Standardinitialisierung
  // Wenn Sie diese Funktionen nicht nutzen und die Gre Ihrer fertigen 
  //  ausfhrbaren Datei reduzieren wollen, sollten Sie die nachfolgenden
  //  spezifischen Initialisierungsroutinen, die Sie nicht bentigen, entfernen.

  #ifdef _AFXDLL
    Enable3dControls();			// Diese Funktion bei Verwendung von MFC in gemeinsam genutzten DLLs aufrufen
  #else
    Enable3dControlsStatic();	// Diese Funktion bei statischen MFC-Anbindungen aufrufen
  #endif

  // ndern des Registrierungsschlssels, unter dem unsere Einstellungen gespeichert sind.
  // ZU ERLEDIGEN: Sie sollten dieser Zeichenfolge einen geeigneten Inhalt geben
  // wie z.B. den Namen Ihrer Firma oder Organisation.
  SetRegistryKey(_T("Local AppWizard-Generated Applications"));

  // Dieser Code erstellt ein neues Rahmenfensterobjekt und setzt dies
  // dann als das Hauptfensterobjekt der Anwendung, um das Hauptfenster zu erstellen.

  CMainFrame* pFrame = new CMainFrame;
  m_pMainWnd = pFrame; Win=pFrame;

  // Rahmen mit Ressourcen erstellen und laden

  pFrame->LoadFrame(IDR_MAINFRAME, WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE, NULL, NULL);

  // Das einzige Fenster ist initialisiert und kann jetzt angezeigt und aktualisiert werden.
  pFrame->ShowWindow(SW_SHOW);
  pFrame->UpdateWindow();

  RV_Init(); RV_Quality=2; RV_AntiAlias=0; RV_Filter=0;

  RV_Lights = new RV_Light; RV_Lights->next=NULL; RV_Lights->Prim=NULL; RV_Lights->v=1.0f;

  InitSphereScene(); cframe=0;
  return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// cRaViApp Nachrichten-Handler


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialog fr Info ber Anwendung

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogdaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// berladungen fr virtuelle Funktionen, die vom Anwendungs-Assistenten erzeugt wurden
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No Message-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void cRaViApp::OnAppAbout()
{
  CAboutDlg aboutDlg;
  aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// cRaViApp-Nachrichtenbehandlungsroutinen

DWORD ts,tc; short int cnt=0; char fd[80];

BOOL cRaViApp::OnIdle(LONG lCount) 
{
  if(!cnt) ts = GetTickCount(); // start timer at first frame
  // calculate scene animation and camera movement
  float w; *RV_CamPtr = 7.0f*vector((float)(sin(C1)*cos(C2)), -(float)cos(C1)*(float)cos(C2), (float)sin(C2) );
  if(Animation){
	matrix NM;
	switch(Demo){
	  case 1: ((RV_SimpleSphere *)Act1)->position.z = 1.0f+(float)fabs(sin(0.002*(double)GetTickCount()));
              break;
	  case 2: w = 0.001f*(float)GetTickCount();
              ((RV_SimpleSphere *)Act1)->position=vector(cosf(w        ), sinf(w        ), 0.5f);
              ((RV_SimpleSphere *)Act2)->position=vector(cosf(w+2.0944f), sinf(w+2.0944f), 0.5f);
              ((RV_SimpleSphere *)Act3)->position=vector(cosf(w-2.0944f), sinf(w-2.0944f), 0.5f);
			  break;
      case 3: ActM.InitIdentMat(); ActM.Scale(1.5f, 1.5f, 1.5f); ActM.RotateX(0.78539f); ActM.RotateY(0.61548f); ActM.RotateZ(-0.001f*(float)GetTickCount()); NM=ActM; ActM.Translate(0.0f, 0.0f, 1.3f);
              ((RV_TriPara *)Act1)->base=vector(-0.5f, -0.5f, -0.5f)*ActM; ((RV_TriPara *)Act1)->edg2=vector( 1.0f,  0.0f,  0.0f)*NM; ((RV_TriPara *)Act1)->edg1=vector( 0.0f,  1.0f,  0.0f)*NM; InitTP((RV_TriPara *)Act1);
              ((RV_TriPara *)Act2)->base=vector(-0.5f, -0.5f, -0.5f)*ActM; ((RV_TriPara *)Act2)->edg2=vector( 0.0f,  1.0f,  0.0f)*NM; ((RV_TriPara *)Act2)->edg1=vector( 0.0f,  0.0f,  1.0f)*NM; InitTP((RV_TriPara *)Act2);
              ((RV_TriPara *)Act3)->base=vector(-0.5f, -0.5f, -0.5f)*ActM; ((RV_TriPara *)Act3)->edg2=vector( 0.0f,  0.0f,  1.0f)*NM; ((RV_TriPara *)Act3)->edg1=vector( 1.0f,  0.0f,  0.0f)*NM; InitTP((RV_TriPara *)Act3);
              ((RV_TriPara *)Act4)->base=vector( 0.5f,  0.5f,  0.5f)*ActM; ((RV_TriPara *)Act4)->edg1=vector(-1.0f,  0.0f,  0.0f)*NM; ((RV_TriPara *)Act4)->edg2=vector( 0.0f, -1.0f,  0.0f)*NM; InitTP((RV_TriPara *)Act4);
              ((RV_TriPara *)Act5)->base=vector( 0.5f,  0.5f,  0.5f)*ActM; ((RV_TriPara *)Act5)->edg1=vector( 0.0f, -1.0f,  0.0f)*NM; ((RV_TriPara *)Act5)->edg2=vector( 0.0f,  0.0f, -1.0f)*NM; InitTP((RV_TriPara *)Act5);
              ((RV_TriPara *)Act6)->base=vector( 0.5f,  0.5f,  0.5f)*ActM; ((RV_TriPara *)Act6)->edg1=vector( 0.0f,  0.0f, -1.0f)*NM; ((RV_TriPara *)Act6)->edg2=vector(-1.0f,  0.0f,  0.0f)*NM; InitTP((RV_TriPara *)Act6);
			  break;
	  case 4: ActM.InitIdentMat();
              ActM.Translate(2.0f, -1.0f, 0.0f); ActM.RotateZ(-0.00025f*(float)GetTickCount());
              ActM.RotateY(-0.30000f); ActM.Translate(0.0f,  0.0f, 3.0f);
			  RV_Lights->p=vector(0.0f, 0.0f, 0.0f)*ActM; ((RV_SimpleSphere *) Act1)->position=RV_Lights->p;
			  break;
	  case 5: ActM.InitIdentMat(); ActM.RotateX(0.7853981634f); ActM.Translate(0.0f, 0.0f, 1.2071f);
              ActM.RotateZ(-0.001f*(float)GetTickCount());
              ((RV_Torus *)Act1)->Tb=ActM.Inverse(); ((RV_Torus *)Act1)->sinfo->NM = ActM.NTrans();
		      break;
	  case 6: w = 0.001f*(float)GetTickCount();
              ((RV_SimpleSphere *)Act1)->position=vector(cosf(w        ), sinf(w        ), 1.5f);
              ((RV_SimpleSphere *)Act2)->position=vector(cosf(w+2.0944f), sinf(w+2.0944f), 1.5f);
              ((RV_SimpleSphere *)Act3)->position=vector(cosf(w-2.0944f), sinf(w-2.0944f), 1.5f);
			  break;
	}
  }
  // render scene to device independant bitmap
  RV_RenderImage(ViewPort->BMPbits, ViewPort->XRes, ViewPort->YRes, 1); cframe++;
  // blit rendering to window
  CDC *dc = ViewPort->GetDC();
  SetDIBitsToDevice(dc->m_hDC, 0, 0, ViewPort->XRes, ViewPort->YRes, 1, 1, 1, ViewPort->YRes+1, ViewPort->BMPbits, &(ViewPort->BMPinfo), DIB_RGB_COLORS);
  ViewPort->ReleaseDC(dc);
  // display frame counter at statusbar
  DWORD tc=GetTickCount()-ts; cnt++;
  if(tc>500){ // update counter every 0.5 seconds
    sprintf(fd,"%5.2f fps",1000.0f/(float)tc*(float)cnt);
    StatusBar->SetPaneText(0,fd,TRUE); cnt=0;
  }  
  return 1; // indicate we need more idle time
}

void cRaViApp::OnUpdateAnimation(CCmdUI* pCmdUI) { pCmdUI->SetCheck(Animation); }
void cRaViApp::OnAnimationToggle() { Animation = !Animation; }

void cRaViApp::OnUpdateAntialias(CCmdUI* pCmdUI) { pCmdUI->SetCheck(RV_AntiAlias); } 
void cRaViApp::OnAntialiasToggle() { RV_AntiAlias = !RV_AntiAlias; } 

void cRaViApp::OnUpdateFilter(CCmdUI* pCmdUI)    { pCmdUI->SetCheck(RV_Filter   ); } 
void cRaViApp::OnFilter()          { RV_Filter    = !RV_Filter;    }

void cRaViApp::OnQuality_1by1()       { RV_Quality=1; }
void cRaViApp::OnQUALITY_4by4()       { RV_Quality=4; }
void cRaViApp::OnQualitySubsampling() { RV_Quality=2; }

void cRaViApp::OnUpdateQuality_1by1(CCmdUI* pCmdUI)    { pCmdUI->SetCheck(RV_Quality==1); }
void cRaViApp::OnUpdateQuality_4by4(CCmdUI* pCmdUI)    { pCmdUI->SetCheck(RV_Quality==4); } 
void cRaViApp::OnUpdateQualitySub(CCmdUI* pCmdUI)      { pCmdUI->SetCheck(RV_Quality==2); }

void cRaViApp::OnMirrorSphere()   { /*KillScene();*/ InitSphereScene();     Demo=1; }
void cRaViApp::OnDemo3Spheres()   { /*KillScene();*/ Init3SpheresScene();   Demo=2; }
void cRaViApp::OnDemoCube()       { /*KillScene();*/ InitCubeScene();       Demo=3; }
void cRaViApp::OnDemoShadows()    { /*KillScene();*/ InitShadowScene();     Demo=4; }
void cRaViApp::OnDemoTorus()      { /*KillScene();*/ InitTorusScene();      Demo=5; }
void cRaViApp::OnDemoSphereHeap() { /*KillScene();*/ InitSphereHeapScene(); Demo=6; }
void cRaViApp::OnDemoAreaLight()  { /*KillScene();*/ InitAreaLightScene();  Demo=7; }

void cRaViApp::OnUpdateDemoMirrSph(CCmdUI* pCmdUI)    { pCmdUI->SetCheck(Demo==1); }
void cRaViApp::OnUpdate3Spheres(CCmdUI* pCmdUI)       { pCmdUI->SetCheck(Demo==2); }
void cRaViApp::OnUpdateDemoCube(CCmdUI* pCmdUI)       { pCmdUI->SetCheck(Demo==3); }
void cRaViApp::OnUpdateShadows(CCmdUI* pCmdUI)        { pCmdUI->SetCheck(Demo==4); }
void cRaViApp::OnUpdateDemoTorus(CCmdUI* pCmdUI)      { pCmdUI->SetCheck(Demo==5); }
void cRaViApp::OnUpdateDemoSphereHeap(CCmdUI* pCmdUI) { pCmdUI->SetCheck(Demo==6); }
void cRaViApp::OnUpdateDemoAreaLight(CCmdUI* pCmdUI)  { pCmdUI->SetCheck(Demo==7); }

void cRaViApp::OnShaderPhong()      { RV_Shader = &Shade;           }
void cRaViApp::OnShaderSimple()     { RV_Shader = &ShadeSimple;     } 
void cRaViApp::OnShaderNormals()    { RV_Shader = &ShadeNormals;    }
void cRaViApp::OnShaderReflection() { RV_Shader = &ShadeReflection;	}
void cRaViApp::OnShaderDepth()      { RV_Shader = &ShadeDepth;      } 
void cRaViApp::OnShaderUV()         { RV_Shader = &ShadeUV;         } 

void cRaViApp::OnUpdateShaderPhong(CCmdUI* pCmdUI)      { pCmdUI->SetCheck(RV_Shader == &Shade          ); }
void cRaViApp::OnUpdateShaderSimple(CCmdUI* pCmdUI)     { pCmdUI->SetCheck(RV_Shader == &ShadeSimple    ); } 
void cRaViApp::OnUpdateShaderNormals(CCmdUI* pCmdUI)    { pCmdUI->SetCheck(RV_Shader == &ShadeNormals   ); }
void cRaViApp::OnUpdateShaderReflection(CCmdUI* pCmdUI) { pCmdUI->SetCheck(RV_Shader == &ShadeReflection); }
void cRaViApp::OnUpdateShaderDepth(CCmdUI* pCmdUI)      { pCmdUI->SetCheck(RV_Shader == &ShadeDepth     ); } 
void cRaViApp::OnUpdateShaderUV(CCmdUI* pCmdUI)         { pCmdUI->SetCheck(RV_Shader == &ShadeUV        ); } 

extern CMainFrame *FrmWin;

void SizeWin(int w, int h) 
{
  int cx = w+2*GetSystemMetrics(SM_CXSIZEFRAME)+4;
  int cy = h+2*GetSystemMetrics(SM_CYSIZEFRAME)+GetSystemMetrics(SM_CYCAPTION)+GetSystemMetrics(SM_CYMENU)+22;
  RECT win; FrmWin->GetWindowRect(&win);
  FrmWin->MoveWindow(win.left, win.top, cx, cy, TRUE);	
}

void cRaViApp::OnRes320() { SizeWin(320,240); }
void cRaViApp::OnRes480() { SizeWin(480,360); }
void cRaViApp::OnRes512() { SizeWin(512,384); }
void cRaViApp::OnRes640() { SizeWin(640,480); }
void cRaViApp::OnRes800() { SizeWin(800,600); }

